searchNodes=[{"ref":"ExDoc.Highlighter.html","title":"ExDoc.Highlighter","module":"ExDoc.Highlighter","type":"module","doc":"Performs code highlighting."},{"ref":"ExDoc.Highlighter.html#assets/1","title":"ExDoc.Highlighter.assets/1","module":"ExDoc.Highlighter","type":"function","doc":"Highlighter specific assets."},{"ref":"ExDoc.Highlighter.html#before_closing_body_tag/1","title":"ExDoc.Highlighter.before_closing_body_tag/1","module":"ExDoc.Highlighter","type":"function","doc":"Highlighter specific annotations."},{"ref":"ExDoc.Highlighter.html#before_closing_head_tag/1","title":"ExDoc.Highlighter.before_closing_head_tag/1","module":"ExDoc.Highlighter","type":"function","doc":"Highlighter specific annotations."},{"ref":"ExDoc.Highlighter.html#highlight_code_blocks/1","title":"ExDoc.Highlighter.highlight_code_blocks/1","module":"ExDoc.Highlighter","type":"function","doc":"Highlights all code block in an already generated HTML document."},{"ref":"Mix.Tasks.Docs.html","title":"Mix.Tasks.Docs","module":"Mix.Tasks.Docs","type":"task","doc":"Uses ExDoc to generate a static web page from the project documentation. Command line options --canonical, -n - Indicate the preferred URL with rel=&quot;canonical&quot; link element, defaults to no canonical path --formatter, -f - Which formatters to use, &quot;html&quot; or &quot;epub&quot;, default: &quot;html&quot; (may be given more than once) --output, -o - Output directory for the generated docs, default: &quot;doc&quot; The command line options have higher precedence than the options specified in your mix.exs file below. Configuration ExDoc will automatically pull in information from your project, like the application and version. However, you may want to set :name, :source_url and :homepage_url to have a nicer output from ExDoc, for example: def project do [app: :my_app, version: &quot;0.1.0-dev&quot;, deps: deps(), # Docs name: &quot;My App&quot;, source_url: &quot;https://github.com/USER/PROJECT&quot;, homepage_url: &quot;http://YOUR_PROJECT_HOMEPAGE&quot;, docs: [main: &quot;MyApp&quot;, # The main page in the docs logo: &quot;path/to/logo.png&quot;, extras: [&quot;README.md&quot;]]] end ExDoc also allows configuration specific to the documentation to be set. The following options should be put under the :docs key in your project&#39;s main configuration. The :docs options should be a keyword list or a function returning a keyword list that will be lazily executed. :api_reference - Whether to generate api-reference.html; default: true. If this is set to false, :main must also be set. :assets - Path to a directory that will be copied as is to the &quot;assets&quot; directory in the output path. Its entries may be referenced in your docs under &quot;assets/ASSET.EXTENSION&quot;; defaults to no assets directory. :before_closing_body_tag - a function that takes as argument an atom specifying the formatter being used (:html or :epub) and returns a literal HTML string to be included just before the closing body tag (&lt;/body&gt;). The atom given as argument can be used to include different content in both formats. Useful to inject custom assets, such as Javascript. :before_closing_head_tag - a function that takes as argument an atom specifying the formatter being used (:html or :epub) and returns a literal HTML string to be included just before the closing head tag (&lt;/head&gt;). The atom given as argument can be used to include different content in both formats. Useful to inject custom assets, such as CSS stylesheets. :canonical - String that defines the preferred URL with the rel=&quot;canonical&quot; element; defaults to no canonical path. :deps - A keyword list application names and their documentation URL. ExDoc will by default include all dependencies and assume they are hosted on HexDocs. This can be overridden by your own values. Example: [plug: &quot;https://myserver/plug/&quot;] :extra_section - String that defines the section title of the additional Markdown pages; default: &quot;PAGES&quot;. Example: &quot;GUIDES&quot; :extras - List of keywords, each key must indicate the path to additional Markdown pages, the value for each keyword (optional) gives you more control about the PATH and the title of the output files; default: []. Example: [&quot;README.md&quot;, &quot;CONTRIBUTING.md&quot;: [filename: &quot;contributing&quot;, title: &quot;Contributing&quot;]] :filter_prefix - Include only modules that match the given prefix in the generated documentation. Example: &quot;MyApp.Core&quot; :formatters - Formatter to use; default: [&quot;html&quot;], options: &quot;html&quot;, &quot;epub&quot;. :groups_for_extras, :groups_for_modules, :groups_for_functions - See the &quot;Groups&quot; section :javascript_config_path - Path of an additional JavaScript file to be included on all pages to provide up-to-date data for features like the version dropdown - See the &quot;Additional JavaScript config&quot; section. Example: &quot;../versions.js&quot; :nest_modules_by_prefix - See the &quot;Nesting&quot; section :language - Identify the primary language of the documents, its value must be a valid BCP 47 language tag; default: &quot;en&quot; :logo - Path to the image logo of the project (only PNG or JPEG accepted) The image size will be 64x64. When specified, the logo will be placed under the &quot;assets&quot; directory in the output path under the name &quot;logo&quot; and the appropriate extension. :main - Main page of the documentation. It may be a module or a generated page, like &quot;Plug&quot; or &quot;api-reference&quot;; default: &quot;api-reference&quot;. :markdown_processor - The markdown processor to use; :markdown_processor_options - Configuration options for the markdown processor; :source_beam - Path to the beam directory; default: mix&#39;s compile path. :source_ref - The branch/commit/tag used for source link inference; default: &quot;master&quot;. :source_url_pattern - Public URL of the project. Derived from project&#39;s :source_url and :source_ref. Example: &quot;https://github.com/USER/APP/blob/master/%{path}#L%{line}&quot; :output - Output directory for the generated docs; default: &quot;doc&quot;. May be overridden by command line argument. :ignore_apps - Apps to be ignored when generating documentation in an umbrella project. Receives a list of atoms. Example: [:first_app, :second_app]. :skip_undefined_reference_warnings_on - ExDoc warns when it can&#39;t create a Mod.fun/arity reference in the current project docs e.g. because of a typo. This list controls which docs pages to skip the warnings on, which is useful for e.g. deprecation pages; default: []. Groups ExDoc content can be organized in groups. This is done via the :groups_for_extras and :groups_for_modules. For example, imagine you are storing extra guides in your documentation which are organized per directory. In the extras section you have: extras: [ &quot;guides/introduction/foo.md&quot;, &quot;guides/introduction/bar.md&quot;, ... &quot;guides/advanced/baz.md&quot;, &quot;guides/advanced/bat.md&quot;, ] You can have those grouped as follows: groups_for_extras: [ &quot;Introduction&quot;: Path.wildcard(&quot;guides/introduction/*.md&quot;), &quot;Advanced&quot;: Path.wildcard(&quot;guides/advanced/*.md&quot;) ] Or via a regex: groups_for_extras: [ &quot;Introduction&quot;: ~r&quot;/introduction/&quot; &quot;Advanced&quot;: ~r&quot;/advanced/&quot; ] Similar can be done for modules: groups_for_modules: [ &quot;Data types&quot;: [Atom, Regex, URI], &quot;Collections&quot;: [Enum, MapSet, Stream], ] A regex or the string name of the module is also supported. Grouping functions Functions inside a module can also be organized in groups. This is done via the :groups_for_functions configuration which is a keyword list of group titles and filtering functions that receive the documentation metadata of functions as argument. For example, imagine that you have an API client library with a large surface area for all the API endpoints you need to support. It would be helpful to group the functions with similar responsibilities together. In this case in your module you might have: defmodule APIClient do @doc section: :auth def refresh_token(params \\\\ []) @doc subject: :object def update_status(id, new_status) @doc permission: :grant def grant_privilege(resource, privilege) end And then in the configuration you can group these with: groups_for_functions: [ Authentication: &amp; &amp;1[:section] == :auth, Resource: &amp; &amp;1[:subject] == :object, Admin: &amp; &amp;1[:permission] in [:grant, :write] ] A function can belong to a single group only. If multiple group filters match, the first will take precedence. Functions that don&#39;t have a custom group will be listed under the default &quot;Functions&quot; group. Additional JavaScript config Since version 0.20.0 ExDoc includes a way to enrich the documentation with new information without having to re-generate it, through a JavaScript file that can be shared across documentation for multiple versions of the package. If :javascript_config_path is set when building the documentation, this script will be referenced in each page&#39;s &lt;head&gt; using a &lt;script&gt; tag. The script should define data in global JavaScript variables that will be interpreted by ex_doc when viewing the documentation. Currenly supported variables: versionNodes This global JavaScript variable should be providing an array of objects that define all versions of this Mix package which should appear in the package versions dropdown in the documentation sidebar. The versions dropdown allows for switching between package versions&#39; documentation. Example: var versionNodes = [ { version: &quot;v0.0.0&quot;, // version number or name (required) url: &quot;https://hexdocs.pm/ex_doc/0.19.3/&quot; // documentation URL (required) } ] Nesting ExDoc also allows module names in the sidebar to appear nested under a given prefix. The :nest_modules_by_prefix expects a list of module names, such as [Foo.Bar, Bar.Baz]. In this case, a module named Foo.Bar.Baz will appear nested within Foo.Bar and only the name Baz will be shown in the sidebar. Note the Foo.Bar module itself is not affected. This option is mainly intended to improve the display of long module names in the sidebar, particularly when they are too long for the sidebar or when many modules share a long prefix. If you mean to group modules logically or call attention to them in the docs, you should probably use :groups_for_modules (which can be used in conjuction with :nest_modules_by_prefix). Umbrella project ExDoc can be used in an umbrella project and generates a single documentation for all child apps. You can use the :ignore_apps configuration to exclude certain projects in the umbrella from documentation. Generating documentation per each child app can be achieved by running: mix cmd mix docs See mix help cmd for more information."},{"ref":"ExDoc.Markdown.html","title":"ExDoc.Markdown","module":"ExDoc.Markdown","type":"behaviour","doc":"Adapter behaviour and conveniences for converting Markdown to HTML. ExDoc is compatible with any markdown processor that implements the functions defined in this module. The markdown processor can be changed via the :markdown_processor option in your mix.exs or via the :markdown_processor configuration in the :ex_doc configuration. ExDoc supports the following Markdown parsers out of the box: Earmark Cmark ExDoc uses Earmark by default."},{"ref":"ExDoc.Markdown.html#c:assets/1","title":"ExDoc.Markdown.assets/1","module":"ExDoc.Markdown","type":"callback","doc":"Assets specific to the markdown implementation. This callback takes the documentation format (:html or :epub) as an argument and must return a list of pairs of the form {basename, content} where: basename - relative path that will be written inside the doc/ directory. content - is a binary with the full contents of the file that will be written to basename. EPUB Documentation Gotchas Generating HTML documentation is simple, and it works exacly as you would expect for a webpage. The EPUB file format, on the other hand, may cause some surprise. Apparently, an EPUB file expects all assets to have a unique name when discarding the file extension. This creates problems if you include, for example, the files custom.js and custom.css. Because the filename without the extension is equal (custom), you will get an unreadable EPUB. It&#39;s possible to go around this limitation by simply giving the files unique names: custom.js becomes custom-js.js and custom.css becomes custom-css.css Example def callback assets(_) do [{&quot;dist/custom-css.css&quot;, custom_css_content()}, {&quot;dist/custom-js.js&quot;, custom_js_content()}] end"},{"ref":"ExDoc.Markdown.html#c:before_closing_body_tag/1","title":"ExDoc.Markdown.before_closing_body_tag/1","module":"ExDoc.Markdown","type":"callback","doc":"Literal content to be written to the file just before the closing body tag. This callback takes the documentation format (:html or :epub) as an argument and returns a literal string. It is useful when the markdown processor needs to a include extra JavaScript. Example def callback before_closing_body_tag(_) do # Include the Javascript specified in the assets/1 callback ~S(&lt;script src=&quot;dist/custom-js.js&quot;&gt;&lt;/script&gt;) end"},{"ref":"ExDoc.Markdown.html#c:before_closing_head_tag/1","title":"ExDoc.Markdown.before_closing_head_tag/1","module":"ExDoc.Markdown","type":"callback","doc":"Literal content to be written to the file just before the closing head tag. This callback takes the documentation format (:html or :epub) as an argument and returns a literal string. It is useful when the markdown processor needs to a include extra CSS. Example def callback before_closing_head_tag(_) do # Include the CSS specified in the assets/1 callback ~S(&lt;link rel=&quot;stylesheet&quot; href=&quot;dist/custom-css.css&quot;/&gt;) end"},{"ref":"ExDoc.Markdown.html#c:configure/1","title":"ExDoc.Markdown.configure/1","module":"ExDoc.Markdown","type":"callback","doc":"A function that accepts configuration options and configures the markdown processor. It is run once when :ex_doc is loaded, and the return value is discarded. Modules that implement this behaviour will probably store the options somewhere so that they can be accessed when needed. The format of the options as well as what the function does with them is completely up to the module that implements the behaviour."},{"ref":"ExDoc.Markdown.html#get_markdown_processor/0","title":"ExDoc.Markdown.get_markdown_processor/0","module":"ExDoc.Markdown","type":"function","doc":"Gets the current markdown processor set globally."},{"ref":"ExDoc.Markdown.html#put_markdown_processor/1","title":"ExDoc.Markdown.put_markdown_processor/1","module":"ExDoc.Markdown","type":"function","doc":"Changes the markdown processor globally."},{"ref":"ExDoc.Markdown.html#to_html/2","title":"ExDoc.Markdown.to_html/2","module":"ExDoc.Markdown","type":"function","doc":"Converts the given markdown document to HTML."},{"ref":"ExDoc.Markdown.html#c:to_html/2","title":"ExDoc.Markdown.to_html/2","module":"ExDoc.Markdown","type":"callback","doc":"Converts markdown into HTML."},{"ref":"ExDoc.Markdown.Cmark.html","title":"ExDoc.Markdown.Cmark","module":"ExDoc.Markdown.Cmark","type":"module","doc":"ExDoc extension for the Cmark Markdown parser."},{"ref":"ExDoc.Markdown.Cmark.html#assets/1","title":"ExDoc.Markdown.Cmark.assets/1","module":"ExDoc.Markdown.Cmark","type":"function","doc":"Assets specific to the markdown implementation. This callback takes the documentation format (:html or :epub) as an argument and must return a list of pairs of the form {basename, content} where: basename - relative path that will be written inside the doc/ directory. content - is a binary with the full contents of the file that will be written to basename. EPUB Documentation Gotchas Generating HTML documentation is simple, and it works exacly as you would expect for a webpage. The EPUB file format, on the other hand, may cause some surprise. Apparently, an EPUB file expects all assets to have a unique name when discarding the file extension. This creates problems if you include, for example, the files custom.js and custom.css. Because the filename without the extension is equal (custom), you will get an unreadable EPUB. It&#39;s possible to go around this limitation by simply giving the files unique names: custom.js becomes custom-js.js and custom.css becomes custom-css.css Example def callback assets(_) do [{&quot;dist/custom-css.css&quot;, custom_css_content()}, {&quot;dist/custom-js.js&quot;, custom_js_content()}] end Callback implementation for ExDoc.Markdown.assets/1."},{"ref":"ExDoc.Markdown.Cmark.html#available?/0","title":"ExDoc.Markdown.Cmark.available?/0","module":"ExDoc.Markdown.Cmark","type":"function","doc":"Check if the Cmark Markdown parser module is available."},{"ref":"ExDoc.Markdown.Cmark.html#before_closing_body_tag/1","title":"ExDoc.Markdown.Cmark.before_closing_body_tag/1","module":"ExDoc.Markdown.Cmark","type":"function","doc":"Literal content to be written to the file just before the closing body tag. This callback takes the documentation format (:html or :epub) as an argument and returns a literal string. It is useful when the markdown processor needs to a include extra JavaScript. Example def callback before_closing_body_tag(_) do # Include the Javascript specified in the assets/1 callback ~S(&lt;script src=&quot;dist/custom-js.js&quot;&gt;&lt;/script&gt;) end Callback implementation for ExDoc.Markdown.before_closing_body_tag/1."},{"ref":"ExDoc.Markdown.Cmark.html#before_closing_head_tag/1","title":"ExDoc.Markdown.Cmark.before_closing_head_tag/1","module":"ExDoc.Markdown.Cmark","type":"function","doc":"Literal content to be written to the file just before the closing head tag. This callback takes the documentation format (:html or :epub) as an argument and returns a literal string. It is useful when the markdown processor needs to a include extra CSS. Example def callback before_closing_head_tag(_) do # Include the CSS specified in the assets/1 callback ~S(&lt;link rel=&quot;stylesheet&quot; href=&quot;dist/custom-css.css&quot;/&gt;) end Callback implementation for ExDoc.Markdown.before_closing_head_tag/1."},{"ref":"ExDoc.Markdown.Cmark.html#configure/1","title":"ExDoc.Markdown.Cmark.configure/1","module":"ExDoc.Markdown.Cmark","type":"function","doc":"A function that accepts configuration options and configures the markdown processor. It is run once when :ex_doc is loaded, and the return value is discarded. Modules that implement this behaviour will probably store the options somewhere so that they can be accessed when needed. The format of the options as well as what the function does with them is completely up to the module that implements the behaviour. Callback implementation for ExDoc.Markdown.configure/1."},{"ref":"ExDoc.Markdown.Cmark.html#to_html/2","title":"ExDoc.Markdown.Cmark.to_html/2","module":"ExDoc.Markdown.Cmark","type":"function","doc":"Generate HTML output. Cmark takes no options."},{"ref":"ExDoc.Markdown.Earmark.html","title":"ExDoc.Markdown.Earmark","module":"ExDoc.Markdown.Earmark","type":"module","doc":"ExDoc extension for the Earmark MarkDown parser."},{"ref":"ExDoc.Markdown.Earmark.html#assets/1","title":"ExDoc.Markdown.Earmark.assets/1","module":"ExDoc.Markdown.Earmark","type":"function","doc":"Assets specific to the markdown implementation. This callback takes the documentation format (:html or :epub) as an argument and must return a list of pairs of the form {basename, content} where: basename - relative path that will be written inside the doc/ directory. content - is a binary with the full contents of the file that will be written to basename. EPUB Documentation Gotchas Generating HTML documentation is simple, and it works exacly as you would expect for a webpage. The EPUB file format, on the other hand, may cause some surprise. Apparently, an EPUB file expects all assets to have a unique name when discarding the file extension. This creates problems if you include, for example, the files custom.js and custom.css. Because the filename without the extension is equal (custom), you will get an unreadable EPUB. It&#39;s possible to go around this limitation by simply giving the files unique names: custom.js becomes custom-js.js and custom.css becomes custom-css.css Example def callback assets(_) do [{&quot;dist/custom-css.css&quot;, custom_css_content()}, {&quot;dist/custom-js.js&quot;, custom_js_content()}] end Callback implementation for ExDoc.Markdown.assets/1."},{"ref":"ExDoc.Markdown.Earmark.html#available?/0","title":"ExDoc.Markdown.Earmark.available?/0","module":"ExDoc.Markdown.Earmark","type":"function","doc":"Check if the Earmark Markdown parser module is available."},{"ref":"ExDoc.Markdown.Earmark.html#before_closing_body_tag/1","title":"ExDoc.Markdown.Earmark.before_closing_body_tag/1","module":"ExDoc.Markdown.Earmark","type":"function","doc":"Literal content to be written to the file just before the closing body tag. This callback takes the documentation format (:html or :epub) as an argument and returns a literal string. It is useful when the markdown processor needs to a include extra JavaScript. Example def callback before_closing_body_tag(_) do # Include the Javascript specified in the assets/1 callback ~S(&lt;script src=&quot;dist/custom-js.js&quot;&gt;&lt;/script&gt;) end Callback implementation for ExDoc.Markdown.before_closing_body_tag/1."},{"ref":"ExDoc.Markdown.Earmark.html#before_closing_head_tag/1","title":"ExDoc.Markdown.Earmark.before_closing_head_tag/1","module":"ExDoc.Markdown.Earmark","type":"function","doc":"Literal content to be written to the file just before the closing head tag. This callback takes the documentation format (:html or :epub) as an argument and returns a literal string. It is useful when the markdown processor needs to a include extra CSS. Example def callback before_closing_head_tag(_) do # Include the CSS specified in the assets/1 callback ~S(&lt;link rel=&quot;stylesheet&quot; href=&quot;dist/custom-css.css&quot;/&gt;) end Callback implementation for ExDoc.Markdown.before_closing_head_tag/1."},{"ref":"ExDoc.Markdown.Earmark.html#configure/1","title":"ExDoc.Markdown.Earmark.configure/1","module":"ExDoc.Markdown.Earmark","type":"function","doc":"A function that accepts configuration options and configures the markdown processor. It is run once when :ex_doc is loaded, and the return value is discarded. Modules that implement this behaviour will probably store the options somewhere so that they can be accessed when needed. The format of the options as well as what the function does with them is completely up to the module that implements the behaviour. Callback implementation for ExDoc.Markdown.configure/1."},{"ref":"ExDoc.Markdown.Earmark.html#to_html/2","title":"ExDoc.Markdown.Earmark.to_html/2","module":"ExDoc.Markdown.Earmark","type":"function","doc":"Earmark specific options: :gfm - boolean. Turns on Github Flavored Markdown extensions. True by default :breaks - boolean. Only applicable if gfm is enabled. Makes all line breaks significant (so every line in the input is a new line in the output) :smartypants - boolean. Turns on smartypants processing, so quotes become curly, two or three hyphens become en and em dashes, and so on. False by default :plugins - map of strings to modules. Register custom plugins to be used with Earmark. See Plugins for details on how to write custom plugins."},{"ref":"ExDoc.FunctionNode.html","title":"ExDoc.FunctionNode","module":"ExDoc.FunctionNode","type":"module","doc":"Structure that represents an individual function."},{"ref":"ExDoc.FunctionNode.html#t:t/0","title":"ExDoc.FunctionNode.t/0","module":"ExDoc.FunctionNode","type":"type","doc":""},{"ref":"ExDoc.ModuleNode.html","title":"ExDoc.ModuleNode","module":"ExDoc.ModuleNode","type":"module","doc":"Structure that represents a module."},{"ref":"ExDoc.ModuleNode.html#t:t/0","title":"ExDoc.ModuleNode.t/0","module":"ExDoc.ModuleNode","type":"type","doc":""},{"ref":"ExDoc.TypeNode.html","title":"ExDoc.TypeNode","module":"ExDoc.TypeNode","type":"module","doc":"Structure that represents an individual type."},{"ref":"ExDoc.TypeNode.html#t:t/0","title":"ExDoc.TypeNode.t/0","module":"ExDoc.TypeNode","type":"type","doc":""},{"ref":"readme.html","title":"ExDoc","module":"readme","type":"extras","doc":"ExDoc ExDoc is a tool to generate documentation for your Elixir projects. In case you are looking for documentation for Elixir itself, check out Elixir&#39;s website. To learn about how to document your projects check out Elixir&#39;s writing documentation page. See the ExDoc Documentation."},{"ref":"readme.html#using-exdoc-with-mix","title":"ExDoc - Using ExDoc with Mix","module":"readme","type":"extras","doc":"To use ExDoc in your Mix projects, first add ExDoc as a dependency. If you are using Elixir v1.7 and later: def deps do [ {:ex_doc, &quot;~&gt; 0.19&quot;, only: :dev, runtime: false}, ] end If you are using Elixir v1.6 and earlier: def deps do [ {:ex_doc, &quot;~&gt; 0.18.0&quot;, only: :dev, runtime: false}, ] end After adding ExDoc as a dependency, run mix deps.get to install it. ExDoc will automatically pull in information from your projects, like the application and version. However, you may want to set :name, :source_url and :homepage_url to have a nicer output from ExDoc, such as: def project do [ app: :my_app, version: &quot;0.1.0-dev&quot;, deps: deps(), # Docs name: &quot;MyApp&quot;, source_url: &quot;https://github.com/USER/PROJECT&quot;, homepage_url: &quot;http://YOUR_PROJECT_HOMEPAGE&quot;, docs: [ main: &quot;MyApp&quot;, # The main page in the docs logo: &quot;path/to/logo.png&quot;, extras: [&quot;README.md&quot;] ] ] end Now you are ready to generate your project documentation with mix docs. To see all options available when generating docs, run mix help docs."},{"ref":"readme.html#using-exdoc-via-command-line","title":"ExDoc - Using ExDoc via command line","module":"readme","type":"extras","doc":"You can ExDoc via the command line as follows: Install ExDoc as an escript: $ mix escript.install hex ex_doc Then you are ready to use it in your projects. First, move into your project directory and make sure it is already compiled: $ cd PATH_TO_YOUR_PROJECT $ mix compile Next invoke the ex_doc executable from your project: $ ex_doc &quot;PROJECT_NAME&quot; &quot;PROJECT_VERSION&quot; path/to/project/ebin -m &quot;PROJECT_MODULE&quot; -u &quot;https://github.com/GITHUB_USER/GITHUB_REPO&quot; -l path/to/logo.png By default, ex_doc produces HTML files, but, you can also create a EPUB document passing the option --formatter epub: $ PATH_TO_YOUR_EXDOC/bin/ex_doc &quot;PROJECT_NAME&quot; &quot;PROJECT_VERSION&quot; path/to/project/ebin -m &quot;PROJECT_MODULE&quot; -u &quot;https://github.com/GITHUB_USER/GITHUB_REPO&quot; -l path/to/logo.png -f epub For example, here are some acceptable values: PROJECT_NAME =&gt; Ecto PROJECT_VERSION =&gt; 0.1.0 PROJECT_MODULE =&gt; Ecto (the main module provided by the library) GITHUB_USER =&gt; elixir-lang GITHUB_REPO =&gt; ecto"},{"ref":"readme.html#auto-linking","title":"ExDoc - Auto-linking","module":"readme","type":"extras","doc":"ExDoc will automatically generate links across modules and functions if you enclose them in backticks: By referring to a module, function, type or callback from your project, such as `MyModule`, ExDoc will automatically link to those By referring to a module, function, type or callback from Elixir, such as [`String`](https://hexdocs.pm/elixir/String.html), ExDoc will automatically link to Elixir&#39;s stable documentation By referring to a module or function from erlang, such as (`:erlang`), ExDoc will automatically link to the Erlang documentation By referring to a module, function, type or callback from any of your dependencies, such as `MyDep`, ExDoc will automatically link to that dependency documentation on hexdocs.pm (the link can be configured by setting docs: [deps: [my_dep: &quot;https://path/to/docs/&quot;]] in your mix.exs) ExDoc supports linking to modules (`MyModule`), functions (`MyModule.function/1`), types (`t:MyModule.type/2`) and callbacks (`c:MyModule.callback/3`). If you want to link a function, type or callback in the current module, you may skip the module name, such as `function/1`."},{"ref":"readme.html#changing-the-markdown-tool","title":"ExDoc - Changing the Markdown tool","module":"readme","type":"extras","doc":"In the examples above, we have used Earmark to convert Markdown to HTML. If you prefer, you can also use cmark (in C). Cmark Cmark is a CommonMark parser written in C. To use cmark add the elixir NIF wrapper cmark.ex as a dependency to your project: {:cmark, &quot;~&gt; 0.6&quot;, only: :dev} Update your project configuration to use Cmark: docs: [markdown_processor: ExDoc.Markdown.Cmark]"},{"ref":"readme.html#contributing","title":"ExDoc - Contributing","module":"readme","type":"extras","doc":"The easiest way to test changes to ExDoc is to locally re-generate it&#39;s own docs: Run mix setup to install all dependencies Run mix build to generate docs. This is a custom alias that will build assets, recompile ExDoc, and output fresh docs into the doc/ directory Commit both assets/* and formatters/* changes (after running mix build)"},{"ref":"readme.html#license","title":"ExDoc - License","module":"readme","type":"extras","doc":"ExDoc source code is released under Apache 2 License. The generated contents, however, are under different licenses based on projects used to help render HTML, including CSS, JS, and other assets. Check the LICENSE file for more information."},{"ref":"changelog.html","title":"Changelog","module":"changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v0-20-0","title":"Changelog - v0.20.0","module":"changelog","type":"extras","doc":"Enhancements Rework the search bar to provide autocompletion Provide full-text search Automatically generate documentation for defdelegate definitions (requires Elixir v1.8+) Provide keyboard shortcuts (press shift+? to see all available outputs) or click the link at the bottom of the page Add support for versions dropdown to the HTML sidebar. This requires adding a docs_config.js (also configurable) that sets a versionNodes JavaScript variable. Improve mouseover titles on sidebar navigation Bug fixes Do not hide structs in type/callback summary signatures No longer require double click to open up a sidebar on Mobile Safari Keep trailing periods in summaries Fix typespec arg number to start from 1 instead of 0"},{"ref":"changelog.html#v0-19-3","title":"Changelog - v0.19.3","module":"changelog","type":"extras","doc":"Enhancements Include a &quot;goto&quot; link on mouseover for expandable menu items Bug fixes Always expand menu items, even if has a single child Fix sidebar bottom margin on Firefox Fix anchor links sometimes not working by moving js to html head Unify code styling for makeup and hljs Do not replace the content of custom links pointing to Elixir modules Remove border-left on deprecated to not mistake it with a heading"},{"ref":"changelog.html#v0-19-2","title":"Changelog - v0.19.2","module":"changelog","type":"extras","doc":"Enhancements Allow logo in SVG extension Allow functions to be grouped based on metadata Allow api-reference.html page to be disabled Allow nesting of modules by prefix Autolink mix help TASK Warn on undefined remote functions from project&#39;s docs Bug fixes Sort function names alphabetically in the sidebar Fix search input color Disable earmark smartypants option"},{"ref":"changelog.html#v0-19-1","title":"Changelog - v0.19.1","module":"changelog","type":"extras","doc":"Enhancements Update CSS styles Remove sourcemaps from package"},{"ref":"changelog.html#v0-19-0","title":"Changelog - v0.19.0","module":"changelog","type":"extras","doc":"This release requires Elixir v1.7 and later. For earlier Elixir versions, use ExDoc ~&gt; 0.18.0. Enhancements Do not select &quot;iex&gt;&quot; when selecting code samples Use makeup to perform ELixir&#39;s syntax highlighting (other languages still use highlight.js) Use [rel=&quot;noopener&quot;] on external links Link directly to page if sidebar item has no subitems Autolink Kernel and Kernel functions and special forms with shorthands (for example, only is_atom/1 is necessary) Trim EEx contents to reduce HTML size Allow apps to be excluded from umbrella app docs Bug fixes Exclude types with @typedoc false from the docs Make sure autolink considers the longest matching dependency name in case of shared prefixes"},{"ref":"changelog.html#v0-18-3","title":"Changelog - v0.18.3","module":"changelog","type":"extras","doc":"Bug fix Fix formatting of typespecs causing errors Update jQuery Properly remove underscore from typespec links"},{"ref":"changelog.html#v0-18-2","title":"Changelog - v0.18.2","module":"changelog","type":"extras","doc":"Enhancements Improve documentation pages for printing Autolink Kernel, Kernel.SpecialForms, and built-in types Annotate opaque types Add vertical-align:top to tables Allow module-function-arity references in links, for example: some code Remove underscore from view source link Run code formatter on typespecs (if one is available) Make night mode switch link more obvious"},{"ref":"changelog.html#v0-18-1","title":"Changelog - v0.18.1","module":"changelog","type":"extras","doc":"Bug fixes Include missing formatter files"},{"ref":"changelog.html#v0-18-0","title":"Changelog - v0.18.0","module":"changelog","type":"extras","doc":"Enhancements No longer strip empty parens from types Provide more extension point for markdown processors Remove assets from priv since they are now embedded at compile time Backwards incompatible changes Remove built-in support for hoedown markdown processor No longer add favicon when logo option is present (this was added in 0.17.0 but it was reported the logo almost never fits as a favicon)"},{"ref":"changelog.html#v0-17-1","title":"Changelog - v0.17.1","module":"changelog","type":"extras","doc":"Bug fixes Fix broken search caused by outdated JavaScript files"},{"ref":"changelog.html#v0-17-0","title":"Changelog - v0.17.0","module":"changelog","type":"extras","doc":"Enhancements Allow modules to be grouped on the sidebar with the :groups_for_modules option Allow extras to be grouped on the sidebar with the :groups_for_extras option Backwards incompatible changes The previous :group option that could be specified for each entry in :extras is no longer supported No longer add a specific section for &quot;Protocols&quot;. If you would like to segregate the protocols in your application, use the new :groups_for_modules functionality"},{"ref":"changelog.html#v0-16-4","title":"Changelog - v0.16.4","module":"changelog","type":"extras","doc":"Enhancements Generate favicon link if a logo is available Bug fixes Do not version epub filename as the doc directory is likely already versioned"},{"ref":"changelog.html#v0-16-3","title":"Changelog - v0.16.3","module":"changelog","type":"extras","doc":"Enhancements Make sure its own search.html page and provide history Generate source maps only if the --debug flag is given Users can now add custom HTML before the closing head tag and the closing body tag Highlight the target function/macro/type/callback when clicked Bug fixes Remove extra term() argument at start of macro spec Add unencoded link target for functions with special chars to cope with different behaviour in browsers"},{"ref":"changelog.html#v0-16-2","title":"Changelog - v0.16.2","module":"changelog","type":"extras","doc":"Enhancements Link &lt;h3&gt; headers as well Add border to code tag Bug fixes Fix sidebar on mobile devices"},{"ref":"changelog.html#v0-16-1","title":"Changelog - v0.16.1","module":"changelog","type":"extras","doc":"Bug fixes Fix hover icons coloring"},{"ref":"changelog.html#v0-16-0","title":"Changelog - v0.16.0","module":"changelog","type":"extras","doc":"Enhancements Separate tasks into &quot;Mix Tasks&quot; in sidebar Add types to the search results Improve accessibility Bug fixes Strip nesting HTML tags in h2 headers Remove the old search results after every new search attempt"},{"ref":"changelog.html#v0-15-1","title":"Changelog - v0.15.1","module":"changelog","type":"extras","doc":"Bug fixes Improve project name wrapping on HTML Properly set link in types with parameter Fix ExDoc.CLI.main/2 to keep --source-ref on Elixir v1.4 Do not fail if localStorage is not available"},{"ref":"changelog.html#v0-15-0","title":"Changelog - v0.15.0","module":"changelog","type":"extras","doc":"Enhancements Closing the search takes you to where you were in the previous page Handle __struct__/0 by displaying the struct instead Warn when redirecting to a non-existent file List both functions and macros under &quot;Functions&quot; Automatically detect GitLab source URL patterns Bug fixes Break long specs into lines Fix the initial state of the sidebar hamburger Do not error when abstract code is missing Properly link to erlang lib dirs Backwards incompatible changes No longer support Pandoc Require Earmark 1.1"},{"ref":"changelog.html#v0-14-5","title":"Changelog - v0.14.5","module":"changelog","type":"extras","doc":"Enhancements Allow ExDoc to work as an escript"},{"ref":"changelog.html#v0-14-4","title":"Changelog - v0.14.4","module":"changelog","type":"extras","doc":"Enhancements Point to Elixir docs on hexdocs.pm Many improvements to layout and styling of EPUB formatter Support multiple formatters to be configured on mix.exs Also digest sidebar_items.js Force parentheses on type signature to remove ambiguity Generate top-level docs for an umbrella project Searching on mobile closes menu when the Enter key is hit"},{"ref":"changelog.html#v0-14-3","title":"Changelog - v0.14.3","module":"changelog","type":"extras","doc":"Enhancements Support the :assets option that automatically copies all entries in the given directory to doc/assets Remove numbering on Extras subheaders from sidebar Pass file and line information to markdown formatters for better warnings Allow extra pages to be grouped together under a given heading Generate ids for default name/arity pairs so they can be linked (both remotely and locally) Bug fixes Fix autolink for functions containing %, {, } or uppercase characters in the name"},{"ref":"changelog.html#v0-14-2","title":"Changelog - v0.14.2","module":"changelog","type":"extras","doc":"Enhancements Automatically generate documentations links to any of your dependencies (by default links to hexdocs.pm but allows the URL to be configured) Allow documentation to be generated to Erlang modules Bug fixes Make sure &quot;Top&quot; is not included twice on pages"},{"ref":"changelog.html#v0-14-1","title":"Changelog - v0.14.1","module":"changelog","type":"extras","doc":"Bug fixes Include &quot;Top&quot; link in pages with no headings Include &quot;Top&quot; link in modules with no docs"},{"ref":"changelog.html#v0-14-0","title":"Changelog - v0.14.0","module":"changelog","type":"extras","doc":"Enhancements Add support for the epub formatter Support extraction from &lt;h2&gt; headers out of the settext format Layout changes Indent documentation inside the function/macro/type/callback header Style types the same way as function/macro/callback and include a link to the source Increase font-sizes in the sidebar and code snippets Move the specs definition inside the function/macro/type/callback header and make better use of vertical space Use a gradient on the sidebar to avoid sudden cut-off when scrolling the modules list Fix the use of the back-button in some browsers Allow the whole sidebar to be navigated without moving away from the current page. Expand (+) and collapse (-) buttons have been added to aid exploration Numerically order pages/guides headers"},{"ref":"changelog.html#v0-13-2","title":"Changelog - v0.13.2","module":"changelog","type":"extras","doc":"Bug fixes Avoid scrollbar from appearing on all code snippets"},{"ref":"changelog.html#v0-13-1","title":"Changelog - v0.13.1","module":"changelog","type":"extras","doc":"Enhancements Autolink Elixir&#39;s stdlib modules and functions Show callbacks in search results Reduce size taken by font-sizes Increase size for headings in the moduledoc Bug fixes Fix opened sidebar on small screens Allow horizontal scrolling for code snippets on small screens"},{"ref":"changelog.html#v0-13-0","title":"Changelog - v0.13.0","module":"changelog","type":"extras","doc":"Bug fixes Fix issue where docs would fail when being built on Erlang 19 Store templates in priv rather than in lib Backwards incompatible changes Require Elixir ~&gt; v1.2"},{"ref":"changelog.html#v0-12-0","title":"Changelog - v0.12.0","module":"changelog","type":"extras","doc":"Enhancements Remove warnings when running on Elixir v1.3 Support for @optional_callbacks Improve styling for nested lists Include earmark as a default dependency Bug fixes Fix many styling and performance front-end related bugs"},{"ref":"changelog.html#v0-11-5","title":"Changelog - v0.11.5","module":"changelog","type":"extras","doc":"Enhancements Support canonical URLs Bug fixes Autolink now allows digits in function names Sort specs by line to preserve ordering Focus on content element on document ready Remove ligature fix on Firefox and Safari as Google Fonts have been updated"},{"ref":"changelog.html#v0-11-4","title":"Changelog - v0.11.4","module":"changelog","type":"extras","doc":"Bug fixes Fix ligature issues in recent browsers HTML escape headers Avoid warning on Elixir master (v1.3)"},{"ref":"changelog.html#v0-11-3","title":"Changelog - v0.11.3","module":"changelog","type":"extras","doc":"Bug fixes Fix a regression where the sidebar wouldn&#39;t stick on small screens"},{"ref":"changelog.html#v0-11-2","title":"Changelog - v0.11.2","module":"changelog","type":"extras","doc":"Enhancements Include night mode for docs Take advantage of extra space on large screens by widening sidebar Bug fixes Do not attempt to retrieve docs from Erlang modules"},{"ref":"changelog.html#v0-11-1","title":"Changelog - v0.11.1","module":"changelog","type":"extras","doc":"Bug fixes Include callbacks even if a module defines a struct"},{"ref":"changelog.html#v0-11-0","title":"Changelog - v0.11.0","module":"changelog","type":"extras","doc":"Enhancements From now on it&#39;s possible to set the title in the sidebar area for additional content, default: &quot;Pages&quot; Set the path and title of each additional page in mix.exs file Use the first h1 as menu title if title is not configured Include the project name as part of the header in small devices Bug fixes Increase the visual separation between functions Remove the extra- prefix for the additional documentation files Extra large images do not create an overflow in the content"},{"ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","module":"changelog","type":"extras","doc":"Enhancements Many improvements and bug fixes in new layout Reduced build size Overview has been renamed to API Reference All extra content, including API Reference, has been moved to inside &quot;Pages&quot; Extra files are now downcased and prefixed by extra-"},{"ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","module":"changelog","type":"extras","doc":"Enhancements Whole new clean, readable, usable, responsive layout Support for adding logo to generated docs (must be 64x64 pixels) Support for adding extra pages to generated docs Improve formatting of typespecs and callbacks Backwards incompatible changes --readme option and :readme configuration have been removed. Use :extras in your mix.exs file or pass --extra / -e in the command-line (may be given multiple times)"},{"ref":"changelog.html#v0-8-4","title":"Changelog - v0.8.4","module":"changelog","type":"extras","doc":"Bug fixes Generate README.html file instead of readme.html as in previous releases Style fixes in the new layout"},{"ref":"changelog.html#v0-8-3","title":"Changelog - v0.8.3","module":"changelog","type":"extras","doc":"Bug fixes Style fixes in the new layout"},{"ref":"changelog.html#v0-8-2","title":"Changelog - v0.8.2","module":"changelog","type":"extras","doc":"Enhancements Uglify and minify JS and CSS code Performance improvements when building sidebar Redirect from index.html to proper page Bug fixes Style fixes in the new layout"},{"ref":"changelog.html#v0-8-1","title":"Changelog - v0.8.1","module":"changelog","type":"extras","doc":"Bug fixes Style fixes in the new layout"},{"ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","module":"changelog","type":"extras","doc":"Enhancements New and responsive layout without frames"},{"ref":"changelog.html#v0-7-3","title":"Changelog - v0.7.3","module":"changelog","type":"extras","doc":"Bug fixes Update highlight.js with fixes some inlining issues Require latest Earmark"},{"ref":"changelog.html#v0-7-2","title":"Changelog - v0.7.2","module":"changelog","type":"extras","doc":"Bug fixes Support Elixir master Fix error reporting when modules are compiled without docs"},{"ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","module":"changelog","type":"extras","doc":"Enhancements Use type=search for search input Update highlight.js dependency Properly tag code comments as coming from Elixir/IEx unless noted otherwise Add support for hash redirection"},{"ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","module":"changelog","type":"extras","doc":"Enhancements Documentation is now generated at doc to follow OTP &quot;standard&quot;"},{"ref":"changelog.html#v0-6-2","title":"Changelog - v0.6.2","module":"changelog","type":"extras","doc":"Enhancements Improvements to the document structure Add syntax highlight"},{"ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","module":"changelog","type":"extras","doc":"Enhancements Autolink modules and functions in the README Generate ids for callbacks starting with &quot;c:&quot; Ensure group ordering is consistent: TYPES &gt; FUNCTIONS &gt; MACROS &gt; CALLBACKS Allow users to search by Module.function"},{"ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","module":"changelog","type":"extras","doc":"Enhancements Support Elixir v1.0.0-rc1"},{"ref":"changelog.html#v0-5-2","title":"Changelog - v0.5.2","module":"changelog","type":"extras","doc":"Bug fixes Use proper ANSI escape sequence on Mix success messages"},{"ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","module":"changelog","type":"extras","doc":"Enhancements Support Elixir v0.15.0 Add support for Earmark - no need for external processors"},{"ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","module":"changelog","type":"extras","doc":"Enhancements First public release Support pandoc and devinus/markdown as markdown processors"}]